#!/usr/bin/env python3
#-*- coding: utf-8 -*-

#
# (c) Simon Psenner, iteas IT Services GmbH
# simon.psenner@iteas.at
# www.iteas.at
#
import json
import os
import subprocess

from flask import Flask, jsonify, request
from flask_restful import reqparse, abort, Api, Resource

app = Flask(__name__)
api = Api(app)


@app.route('/')
def index():
    return "Hello World!"


# Todo How to deal with multiple Printjobs at a time

class PrintAroma(Resource):
    def post(self):
        data = request.data
        json_data = json.loads(str(data.decode("utf-8")))

        with open('/var/lib/printserver-templates/aroma.zpl', 'r') as myfile:
            data = myfile.read()

        barcode = json_data["barcode"]  # 30000118777000050102040
        country = json_data["country"]  # AT
        lotnumber = json_data["lotnumber"]  # 1877700005
        suppliernumber = json_data["supplier"]  # 300001
        ggnr = json_data["ggnr"] #Zertifikatsnumber
        suppliername = json_data["suppliername"] #Franz Huber
        prodnr = json_data["prodnr"]  # 102
        prodname = json_data["prodname"]  # Idared
        amount = json_data["amount"]  # 40
        container = json_data["container"] #GKP
        cell = json_data["cell"] #Zelle CA-4
        certs = json_data["certs"]  # GGAP
        lsnr = json_data["lsnr"] #Lieferscheinnumber
        year = json_data["year"]  # 2017
        devdate = json_data["devdate"]  # 02.11.2017
        pages = int(json_data["pages"])  # 2

        with open("/tmp/aromaout.zpl", "w+") as file:
            file.write(data % (barcode, country, lotnumber, suppliernumber, ggnr, suppliername, prodnr, prodname, amount, container, cell, certs, lsnr, year, devdate))

        count = 0
        while count < pages:
            count += 1
            print("printing")
            subprocess.call(["lpr -PZebra_ZD420 -o raw /tmp/aromaout.zpl"], shell=True)

        return jsonify(message="Printjob Recived")


class PrintZinner(Resource):
    def post(self):
        json_data = request.get_json(force=True)

        with open('/var/lib/printserver-templates/label.zpl', 'r') as myfile:
            data = myfile.read()

        barcode = json_data["barcode"]  # 30000118777000050102040
        country = json_data["country"]  # AT
        lotnumber = json_data["lotnumber"]  # 1877700005
        suppliernumber = json_data["supplier"]  # 300001
        ggnr = json_data["ggnr"]  # Zertifikatsnumber
        suppliername = json_data["suppliername"]  # Franz Huber
        prodnr = json_data["prodnr"]  # 102
        prodname = json_data["prodname"]  # Idared
        amount = json_data["amount"]  # 40
        container = json_data["container"]  # GKP
        cell = json_data["cell"]  # Zelle CA-4
        certs = json_data["certs"]  # GGAP
        lsnr = json_data["lsnr"]  # Lieferscheinnumber
        year = json_data["year"]  # 2017
        devdate = json_data["devdate"]  # 02.11.2017
        pages = int(json_data["pages"])  # 2

        with open("/tmp/zinnerout.zpl", "w+") as file:
            file.write(data % (barcode, country, lotnumber, suppliernumber, ggnr, suppliername, prodnr, prodname, amount, container, cell, certs, lsnr, year, devdate))

        count = 0
        while count < pages:
            count += 1
            print("printing")
            subprocess.call(["lpr -PZebra_ZD420 -o raw /tmp/zinnerout.zpl"], shell=True)


api.add_resource(PrintAroma, '/aroma')
api.add_resource(PrintZinner, '/zinner')

if __name__ == "__main__":
    app.run(host='0.0.0.0', port=8080, debug=True)
